c234567 
c Exemple d'un programme utilisant une subroutine  et une fonction 
       program tp2
c déclaration des variables en explicite
       implicit none 
       double precision a,b,x,z,p
       integer i,n,m
       dimension x(1000),z(1000),p(1000)
       double precision f1
       external f1
c fin des déclarations
       a = -5.0d0
       b =  5.0d0


c On ecrit dans le fichier f1.dat les abscisses et ordonnees de la fonction f1 (c.f. ci-dessous)      
       open(1,file='f1.dat')
       do i=1,100
         x(i)=a+(b-a)/99.0d0*dble(i-1)
         write(1,*) x(i),f1(x(i))
       enddo
       close(1)

c on appelle la procdeure interp via "call"        
       m = 100 
       call interp(3,a,b,f1,z,p,m)
       open(2,file='interp1.dat')
        do i=1,m+1
           write(2,*) z(i), p(i)
        enddo
       close(2)
       end
C FIN DU PROGRAMME
C=======================================================================================================
C=======================================================================================================
C NOTE: pour tracer la fonction f1 et le polynome p dans une meme fenetre graphique
c on lance gnuplot et on lance la commande
c plot 'f1.dat' u 1:2 w l title "f1", 'interp1.dat' u 1:2 w l title "p1" 
C=======================================================================================================
C=======================================================================================================
       function f1(x)
       implicit none
       double precision f1,x
       f1 = 1.0d0/(1.0d0+x**2.0d0) 
c      f1 = dcos(x)
       end 
C=======================================================================================================
c Cette subroutine permet de calculer l'interpolation d'une fonction f a l'aide des différences divisées.
       subroutine interp (n,a,b,f,z,p,m) 
       implicit none
       double precision a,b
       integer i,j,k,n,m,h
       double precision div,x,z(*),p(*)
       dimension div(1000,1000),x(1000)
       double precision f
       external f
c initialisation 
       do i=1,n
         x(i)=a+(b-a)/dble(n-1)*dble(i-1)
         DIV(i,1)=f(x(i))  
       enddo
c methode des differences divisees       
       do i=2,n
         do j=i,n
          DIV(j,i)=(DIV(j,i-1)-DIV(j-1,i-1))/(x(j)-x(j-i+1))
         enddo
       enddo
c ecriture des resultats dans un fichier pour utilisation avec gnuplot       
       do i=1,m+1
         z(i)=a+(b-a)/m*dble(i-1)
       enddo
       do h=1,m                                   
          p(h)=DIV(n,n);
          k=n-1
          do while  (k.ge.1)
           p(h)=DIV(k,k)+(z(h)-x(k))*p(h)
           k=k-1;
          enddo
        enddo
       end
C=======================================================================================================
